// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2018 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package dcim

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewDcimRearPortsListParams creates a new DcimRearPortsListParams object
// with the default values initialized.
func NewDcimRearPortsListParams() *DcimRearPortsListParams {
	var ()
	return &DcimRearPortsListParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewDcimRearPortsListParamsWithTimeout creates a new DcimRearPortsListParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewDcimRearPortsListParamsWithTimeout(timeout time.Duration) *DcimRearPortsListParams {
	var ()
	return &DcimRearPortsListParams{

		timeout: timeout,
	}
}

// NewDcimRearPortsListParamsWithContext creates a new DcimRearPortsListParams object
// with the default values initialized, and the ability to set a context for a request
func NewDcimRearPortsListParamsWithContext(ctx context.Context) *DcimRearPortsListParams {
	var ()
	return &DcimRearPortsListParams{

		Context: ctx,
	}
}

// NewDcimRearPortsListParamsWithHTTPClient creates a new DcimRearPortsListParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewDcimRearPortsListParamsWithHTTPClient(client *http.Client) *DcimRearPortsListParams {
	var ()
	return &DcimRearPortsListParams{
		HTTPClient: client,
	}
}

/*DcimRearPortsListParams contains all the parameters to send to the API endpoint
for the dcim rear ports list operation typically these are written to a http.Request
*/
type DcimRearPortsListParams struct {

	/*Cabled*/
	Cabled *string
	/*Description*/
	Description *string
	/*Device*/
	Device *string
	/*DeviceID*/
	DeviceID *string
	/*ID*/
	ID *string
	/*Limit
	  Number of results to return per page.

	*/
	Limit *int64
	/*Name*/
	Name *string
	/*Offset
	  The initial index from which to return the results.

	*/
	Offset *int64
	/*Positions*/
	Positions *string
	/*Q*/
	Q *string
	/*Region*/
	Region *string
	/*RegionID*/
	RegionID *string
	/*Site*/
	Site *string
	/*SiteID*/
	SiteID *string
	/*Tag*/
	Tag *string
	/*Type*/
	Type *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithTimeout(timeout time.Duration) *DcimRearPortsListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithContext(ctx context.Context) *DcimRearPortsListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithHTTPClient(client *http.Client) *DcimRearPortsListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithCabled adds the cabled to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithCabled(cabled *string) *DcimRearPortsListParams {
	o.SetCabled(cabled)
	return o
}

// SetCabled adds the cabled to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetCabled(cabled *string) {
	o.Cabled = cabled
}

// WithDescription adds the description to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithDescription(description *string) *DcimRearPortsListParams {
	o.SetDescription(description)
	return o
}

// SetDescription adds the description to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetDescription(description *string) {
	o.Description = description
}

// WithDevice adds the device to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithDevice(device *string) *DcimRearPortsListParams {
	o.SetDevice(device)
	return o
}

// SetDevice adds the device to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetDevice(device *string) {
	o.Device = device
}

// WithDeviceID adds the deviceID to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithDeviceID(deviceID *string) *DcimRearPortsListParams {
	o.SetDeviceID(deviceID)
	return o
}

// SetDeviceID adds the deviceId to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetDeviceID(deviceID *string) {
	o.DeviceID = deviceID
}

// WithID adds the id to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithID(id *string) *DcimRearPortsListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetID(id *string) {
	o.ID = id
}

// WithLimit adds the limit to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithLimit(limit *int64) *DcimRearPortsListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithName adds the name to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithName(name *string) *DcimRearPortsListParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetName(name *string) {
	o.Name = name
}

// WithOffset adds the offset to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithOffset(offset *int64) *DcimRearPortsListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithPositions adds the positions to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithPositions(positions *string) *DcimRearPortsListParams {
	o.SetPositions(positions)
	return o
}

// SetPositions adds the positions to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetPositions(positions *string) {
	o.Positions = positions
}

// WithQ adds the q to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithQ(q *string) *DcimRearPortsListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetQ(q *string) {
	o.Q = q
}

// WithRegion adds the region to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithRegion(region *string) *DcimRearPortsListParams {
	o.SetRegion(region)
	return o
}

// SetRegion adds the region to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetRegion(region *string) {
	o.Region = region
}

// WithRegionID adds the regionID to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithRegionID(regionID *string) *DcimRearPortsListParams {
	o.SetRegionID(regionID)
	return o
}

// SetRegionID adds the regionId to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetRegionID(regionID *string) {
	o.RegionID = regionID
}

// WithSite adds the site to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithSite(site *string) *DcimRearPortsListParams {
	o.SetSite(site)
	return o
}

// SetSite adds the site to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetSite(site *string) {
	o.Site = site
}

// WithSiteID adds the siteID to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithSiteID(siteID *string) *DcimRearPortsListParams {
	o.SetSiteID(siteID)
	return o
}

// SetSiteID adds the siteId to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetSiteID(siteID *string) {
	o.SiteID = siteID
}

// WithTag adds the tag to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithTag(tag *string) *DcimRearPortsListParams {
	o.SetTag(tag)
	return o
}

// SetTag adds the tag to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetTag(tag *string) {
	o.Tag = tag
}

// WithType adds the typeVar to the dcim rear ports list params
func (o *DcimRearPortsListParams) WithType(typeVar *string) *DcimRearPortsListParams {
	o.SetType(typeVar)
	return o
}

// SetType adds the type to the dcim rear ports list params
func (o *DcimRearPortsListParams) SetType(typeVar *string) {
	o.Type = typeVar
}

// WriteToRequest writes these params to a swagger request
func (o *DcimRearPortsListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Cabled != nil {

		// query param cabled
		var qrCabled string
		if o.Cabled != nil {
			qrCabled = *o.Cabled
		}
		qCabled := qrCabled
		if qCabled != "" {
			if err := r.SetQueryParam("cabled", qCabled); err != nil {
				return err
			}
		}

	}

	if o.Description != nil {

		// query param description
		var qrDescription string
		if o.Description != nil {
			qrDescription = *o.Description
		}
		qDescription := qrDescription
		if qDescription != "" {
			if err := r.SetQueryParam("description", qDescription); err != nil {
				return err
			}
		}

	}

	if o.Device != nil {

		// query param device
		var qrDevice string
		if o.Device != nil {
			qrDevice = *o.Device
		}
		qDevice := qrDevice
		if qDevice != "" {
			if err := r.SetQueryParam("device", qDevice); err != nil {
				return err
			}
		}

	}

	if o.DeviceID != nil {

		// query param device_id
		var qrDeviceID string
		if o.DeviceID != nil {
			qrDeviceID = *o.DeviceID
		}
		qDeviceID := qrDeviceID
		if qDeviceID != "" {
			if err := r.SetQueryParam("device_id", qDeviceID); err != nil {
				return err
			}
		}

	}

	if o.ID != nil {

		// query param id
		var qrID string
		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {
			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Name != nil {

		// query param name
		var qrName string
		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {
			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.Positions != nil {

		// query param positions
		var qrPositions string
		if o.Positions != nil {
			qrPositions = *o.Positions
		}
		qPositions := qrPositions
		if qPositions != "" {
			if err := r.SetQueryParam("positions", qPositions); err != nil {
				return err
			}
		}

	}

	if o.Q != nil {

		// query param q
		var qrQ string
		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {
			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}

	}

	if o.Region != nil {

		// query param region
		var qrRegion string
		if o.Region != nil {
			qrRegion = *o.Region
		}
		qRegion := qrRegion
		if qRegion != "" {
			if err := r.SetQueryParam("region", qRegion); err != nil {
				return err
			}
		}

	}

	if o.RegionID != nil {

		// query param region_id
		var qrRegionID string
		if o.RegionID != nil {
			qrRegionID = *o.RegionID
		}
		qRegionID := qrRegionID
		if qRegionID != "" {
			if err := r.SetQueryParam("region_id", qRegionID); err != nil {
				return err
			}
		}

	}

	if o.Site != nil {

		// query param site
		var qrSite string
		if o.Site != nil {
			qrSite = *o.Site
		}
		qSite := qrSite
		if qSite != "" {
			if err := r.SetQueryParam("site", qSite); err != nil {
				return err
			}
		}

	}

	if o.SiteID != nil {

		// query param site_id
		var qrSiteID string
		if o.SiteID != nil {
			qrSiteID = *o.SiteID
		}
		qSiteID := qrSiteID
		if qSiteID != "" {
			if err := r.SetQueryParam("site_id", qSiteID); err != nil {
				return err
			}
		}

	}

	if o.Tag != nil {

		// query param tag
		var qrTag string
		if o.Tag != nil {
			qrTag = *o.Tag
		}
		qTag := qrTag
		if qTag != "" {
			if err := r.SetQueryParam("tag", qTag); err != nil {
				return err
			}
		}

	}

	if o.Type != nil {

		// query param type
		var qrType string
		if o.Type != nil {
			qrType = *o.Type
		}
		qType := qrType
		if qType != "" {
			if err := r.SetQueryParam("type", qType); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
