// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2018 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package ipam

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"

	strfmt "github.com/go-openapi/strfmt"
)

// NewIpamChoicesReadParams creates a new IpamChoicesReadParams object
// with the default values initialized.
func NewIpamChoicesReadParams() *IpamChoicesReadParams {
	var ()
	return &IpamChoicesReadParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewIpamChoicesReadParamsWithTimeout creates a new IpamChoicesReadParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewIpamChoicesReadParamsWithTimeout(timeout time.Duration) *IpamChoicesReadParams {
	var ()
	return &IpamChoicesReadParams{

		timeout: timeout,
	}
}

// NewIpamChoicesReadParamsWithContext creates a new IpamChoicesReadParams object
// with the default values initialized, and the ability to set a context for a request
func NewIpamChoicesReadParamsWithContext(ctx context.Context) *IpamChoicesReadParams {
	var ()
	return &IpamChoicesReadParams{

		Context: ctx,
	}
}

// NewIpamChoicesReadParamsWithHTTPClient creates a new IpamChoicesReadParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewIpamChoicesReadParamsWithHTTPClient(client *http.Client) *IpamChoicesReadParams {
	var ()
	return &IpamChoicesReadParams{
		HTTPClient: client,
	}
}

/*IpamChoicesReadParams contains all the parameters to send to the API endpoint
for the ipam choices read operation typically these are written to a http.Request
*/
type IpamChoicesReadParams struct {

	/*ID*/
	ID string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the ipam choices read params
func (o *IpamChoicesReadParams) WithTimeout(timeout time.Duration) *IpamChoicesReadParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ipam choices read params
func (o *IpamChoicesReadParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ipam choices read params
func (o *IpamChoicesReadParams) WithContext(ctx context.Context) *IpamChoicesReadParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ipam choices read params
func (o *IpamChoicesReadParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ipam choices read params
func (o *IpamChoicesReadParams) WithHTTPClient(client *http.Client) *IpamChoicesReadParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ipam choices read params
func (o *IpamChoicesReadParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the ipam choices read params
func (o *IpamChoicesReadParams) WithID(id string) *IpamChoicesReadParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the ipam choices read params
func (o *IpamChoicesReadParams) SetID(id string) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *IpamChoicesReadParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	// path param id
	if err := r.SetPathParam("id", o.ID); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
