// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2018 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package ipam

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewIpamPrefixesListParams creates a new IpamPrefixesListParams object
// with the default values initialized.
func NewIpamPrefixesListParams() *IpamPrefixesListParams {
	var ()
	return &IpamPrefixesListParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewIpamPrefixesListParamsWithTimeout creates a new IpamPrefixesListParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewIpamPrefixesListParamsWithTimeout(timeout time.Duration) *IpamPrefixesListParams {
	var ()
	return &IpamPrefixesListParams{

		timeout: timeout,
	}
}

// NewIpamPrefixesListParamsWithContext creates a new IpamPrefixesListParams object
// with the default values initialized, and the ability to set a context for a request
func NewIpamPrefixesListParamsWithContext(ctx context.Context) *IpamPrefixesListParams {
	var ()
	return &IpamPrefixesListParams{

		Context: ctx,
	}
}

// NewIpamPrefixesListParamsWithHTTPClient creates a new IpamPrefixesListParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewIpamPrefixesListParamsWithHTTPClient(client *http.Client) *IpamPrefixesListParams {
	var ()
	return &IpamPrefixesListParams{
		HTTPClient: client,
	}
}

/*IpamPrefixesListParams contains all the parameters to send to the API endpoint
for the ipam prefixes list operation typically these are written to a http.Request
*/
type IpamPrefixesListParams struct {

	/*Contains*/
	Contains *string
	/*Created*/
	Created *string
	/*CreatedGte*/
	CreatedGte *string
	/*CreatedLte*/
	CreatedLte *string
	/*Family*/
	Family *string
	/*IDIn
	  Multiple values may be separated by commas.

	*/
	IDIn *string
	/*IsPool*/
	IsPool *string
	/*LastUpdated*/
	LastUpdated *string
	/*LastUpdatedGte*/
	LastUpdatedGte *string
	/*LastUpdatedLte*/
	LastUpdatedLte *string
	/*Limit
	  Number of results to return per page.

	*/
	Limit *int64
	/*MaskLength*/
	MaskLength *float64
	/*Offset
	  The initial index from which to return the results.

	*/
	Offset *int64
	/*Prefix*/
	Prefix *string
	/*Q*/
	Q *string
	/*Region*/
	Region *string
	/*RegionID*/
	RegionID *string
	/*Role*/
	Role *string
	/*RoleID*/
	RoleID *string
	/*Site*/
	Site *string
	/*SiteID*/
	SiteID *string
	/*Status*/
	Status *string
	/*Tag*/
	Tag *string
	/*Tenant*/
	Tenant *string
	/*TenantGroup*/
	TenantGroup *string
	/*TenantGroupID*/
	TenantGroupID *string
	/*TenantID*/
	TenantID *string
	/*VlanID*/
	VlanID *string
	/*VlanVid*/
	VlanVid *float64
	/*Vrf*/
	Vrf *string
	/*VrfID*/
	VrfID *string
	/*Within*/
	Within *string
	/*WithinInclude*/
	WithinInclude *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTimeout(timeout time.Duration) *IpamPrefixesListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithContext(ctx context.Context) *IpamPrefixesListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithHTTPClient(client *http.Client) *IpamPrefixesListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithContains adds the contains to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithContains(contains *string) *IpamPrefixesListParams {
	o.SetContains(contains)
	return o
}

// SetContains adds the contains to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetContains(contains *string) {
	o.Contains = contains
}

// WithCreated adds the created to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithCreated(created *string) *IpamPrefixesListParams {
	o.SetCreated(created)
	return o
}

// SetCreated adds the created to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetCreated(created *string) {
	o.Created = created
}

// WithCreatedGte adds the createdGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithCreatedGte(createdGte *string) *IpamPrefixesListParams {
	o.SetCreatedGte(createdGte)
	return o
}

// SetCreatedGte adds the createdGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetCreatedGte(createdGte *string) {
	o.CreatedGte = createdGte
}

// WithCreatedLte adds the createdLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithCreatedLte(createdLte *string) *IpamPrefixesListParams {
	o.SetCreatedLte(createdLte)
	return o
}

// SetCreatedLte adds the createdLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetCreatedLte(createdLte *string) {
	o.CreatedLte = createdLte
}

// WithFamily adds the family to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithFamily(family *string) *IpamPrefixesListParams {
	o.SetFamily(family)
	return o
}

// SetFamily adds the family to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetFamily(family *string) {
	o.Family = family
}

// WithIDIn adds the iDIn to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithIDIn(iDIn *string) *IpamPrefixesListParams {
	o.SetIDIn(iDIn)
	return o
}

// SetIDIn adds the idIn to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetIDIn(iDIn *string) {
	o.IDIn = iDIn
}

// WithIsPool adds the isPool to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithIsPool(isPool *string) *IpamPrefixesListParams {
	o.SetIsPool(isPool)
	return o
}

// SetIsPool adds the isPool to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetIsPool(isPool *string) {
	o.IsPool = isPool
}

// WithLastUpdated adds the lastUpdated to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithLastUpdated(lastUpdated *string) *IpamPrefixesListParams {
	o.SetLastUpdated(lastUpdated)
	return o
}

// SetLastUpdated adds the lastUpdated to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetLastUpdated(lastUpdated *string) {
	o.LastUpdated = lastUpdated
}

// WithLastUpdatedGte adds the lastUpdatedGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithLastUpdatedGte(lastUpdatedGte *string) *IpamPrefixesListParams {
	o.SetLastUpdatedGte(lastUpdatedGte)
	return o
}

// SetLastUpdatedGte adds the lastUpdatedGte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetLastUpdatedGte(lastUpdatedGte *string) {
	o.LastUpdatedGte = lastUpdatedGte
}

// WithLastUpdatedLte adds the lastUpdatedLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithLastUpdatedLte(lastUpdatedLte *string) *IpamPrefixesListParams {
	o.SetLastUpdatedLte(lastUpdatedLte)
	return o
}

// SetLastUpdatedLte adds the lastUpdatedLte to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetLastUpdatedLte(lastUpdatedLte *string) {
	o.LastUpdatedLte = lastUpdatedLte
}

// WithLimit adds the limit to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithLimit(limit *int64) *IpamPrefixesListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithMaskLength adds the maskLength to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithMaskLength(maskLength *float64) *IpamPrefixesListParams {
	o.SetMaskLength(maskLength)
	return o
}

// SetMaskLength adds the maskLength to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetMaskLength(maskLength *float64) {
	o.MaskLength = maskLength
}

// WithOffset adds the offset to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithOffset(offset *int64) *IpamPrefixesListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithPrefix adds the prefix to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithPrefix(prefix *string) *IpamPrefixesListParams {
	o.SetPrefix(prefix)
	return o
}

// SetPrefix adds the prefix to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetPrefix(prefix *string) {
	o.Prefix = prefix
}

// WithQ adds the q to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithQ(q *string) *IpamPrefixesListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetQ(q *string) {
	o.Q = q
}

// WithRegion adds the region to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithRegion(region *string) *IpamPrefixesListParams {
	o.SetRegion(region)
	return o
}

// SetRegion adds the region to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetRegion(region *string) {
	o.Region = region
}

// WithRegionID adds the regionID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithRegionID(regionID *string) *IpamPrefixesListParams {
	o.SetRegionID(regionID)
	return o
}

// SetRegionID adds the regionId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetRegionID(regionID *string) {
	o.RegionID = regionID
}

// WithRole adds the role to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithRole(role *string) *IpamPrefixesListParams {
	o.SetRole(role)
	return o
}

// SetRole adds the role to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetRole(role *string) {
	o.Role = role
}

// WithRoleID adds the roleID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithRoleID(roleID *string) *IpamPrefixesListParams {
	o.SetRoleID(roleID)
	return o
}

// SetRoleID adds the roleId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetRoleID(roleID *string) {
	o.RoleID = roleID
}

// WithSite adds the site to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithSite(site *string) *IpamPrefixesListParams {
	o.SetSite(site)
	return o
}

// SetSite adds the site to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetSite(site *string) {
	o.Site = site
}

// WithSiteID adds the siteID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithSiteID(siteID *string) *IpamPrefixesListParams {
	o.SetSiteID(siteID)
	return o
}

// SetSiteID adds the siteId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetSiteID(siteID *string) {
	o.SiteID = siteID
}

// WithStatus adds the status to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithStatus(status *string) *IpamPrefixesListParams {
	o.SetStatus(status)
	return o
}

// SetStatus adds the status to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetStatus(status *string) {
	o.Status = status
}

// WithTag adds the tag to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTag(tag *string) *IpamPrefixesListParams {
	o.SetTag(tag)
	return o
}

// SetTag adds the tag to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTag(tag *string) {
	o.Tag = tag
}

// WithTenant adds the tenant to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTenant(tenant *string) *IpamPrefixesListParams {
	o.SetTenant(tenant)
	return o
}

// SetTenant adds the tenant to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTenant(tenant *string) {
	o.Tenant = tenant
}

// WithTenantGroup adds the tenantGroup to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTenantGroup(tenantGroup *string) *IpamPrefixesListParams {
	o.SetTenantGroup(tenantGroup)
	return o
}

// SetTenantGroup adds the tenantGroup to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTenantGroup(tenantGroup *string) {
	o.TenantGroup = tenantGroup
}

// WithTenantGroupID adds the tenantGroupID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTenantGroupID(tenantGroupID *string) *IpamPrefixesListParams {
	o.SetTenantGroupID(tenantGroupID)
	return o
}

// SetTenantGroupID adds the tenantGroupId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTenantGroupID(tenantGroupID *string) {
	o.TenantGroupID = tenantGroupID
}

// WithTenantID adds the tenantID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithTenantID(tenantID *string) *IpamPrefixesListParams {
	o.SetTenantID(tenantID)
	return o
}

// SetTenantID adds the tenantId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetTenantID(tenantID *string) {
	o.TenantID = tenantID
}

// WithVlanID adds the vlanID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVlanID(vlanID *string) *IpamPrefixesListParams {
	o.SetVlanID(vlanID)
	return o
}

// SetVlanID adds the vlanId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVlanID(vlanID *string) {
	o.VlanID = vlanID
}

// WithVlanVid adds the vlanVid to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVlanVid(vlanVid *float64) *IpamPrefixesListParams {
	o.SetVlanVid(vlanVid)
	return o
}

// SetVlanVid adds the vlanVid to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVlanVid(vlanVid *float64) {
	o.VlanVid = vlanVid
}

// WithVrf adds the vrf to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVrf(vrf *string) *IpamPrefixesListParams {
	o.SetVrf(vrf)
	return o
}

// SetVrf adds the vrf to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVrf(vrf *string) {
	o.Vrf = vrf
}

// WithVrfID adds the vrfID to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithVrfID(vrfID *string) *IpamPrefixesListParams {
	o.SetVrfID(vrfID)
	return o
}

// SetVrfID adds the vrfId to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetVrfID(vrfID *string) {
	o.VrfID = vrfID
}

// WithWithin adds the within to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithWithin(within *string) *IpamPrefixesListParams {
	o.SetWithin(within)
	return o
}

// SetWithin adds the within to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetWithin(within *string) {
	o.Within = within
}

// WithWithinInclude adds the withinInclude to the ipam prefixes list params
func (o *IpamPrefixesListParams) WithWithinInclude(withinInclude *string) *IpamPrefixesListParams {
	o.SetWithinInclude(withinInclude)
	return o
}

// SetWithinInclude adds the withinInclude to the ipam prefixes list params
func (o *IpamPrefixesListParams) SetWithinInclude(withinInclude *string) {
	o.WithinInclude = withinInclude
}

// WriteToRequest writes these params to a swagger request
func (o *IpamPrefixesListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Contains != nil {

		// query param contains
		var qrContains string
		if o.Contains != nil {
			qrContains = *o.Contains
		}
		qContains := qrContains
		if qContains != "" {
			if err := r.SetQueryParam("contains", qContains); err != nil {
				return err
			}
		}

	}

	if o.Created != nil {

		// query param created
		var qrCreated string
		if o.Created != nil {
			qrCreated = *o.Created
		}
		qCreated := qrCreated
		if qCreated != "" {
			if err := r.SetQueryParam("created", qCreated); err != nil {
				return err
			}
		}

	}

	if o.CreatedGte != nil {

		// query param created__gte
		var qrCreatedGte string
		if o.CreatedGte != nil {
			qrCreatedGte = *o.CreatedGte
		}
		qCreatedGte := qrCreatedGte
		if qCreatedGte != "" {
			if err := r.SetQueryParam("created__gte", qCreatedGte); err != nil {
				return err
			}
		}

	}

	if o.CreatedLte != nil {

		// query param created__lte
		var qrCreatedLte string
		if o.CreatedLte != nil {
			qrCreatedLte = *o.CreatedLte
		}
		qCreatedLte := qrCreatedLte
		if qCreatedLte != "" {
			if err := r.SetQueryParam("created__lte", qCreatedLte); err != nil {
				return err
			}
		}

	}

	if o.Family != nil {

		// query param family
		var qrFamily string
		if o.Family != nil {
			qrFamily = *o.Family
		}
		qFamily := qrFamily
		if qFamily != "" {
			if err := r.SetQueryParam("family", qFamily); err != nil {
				return err
			}
		}

	}

	if o.IDIn != nil {

		// query param id__in
		var qrIDIn string
		if o.IDIn != nil {
			qrIDIn = *o.IDIn
		}
		qIDIn := qrIDIn
		if qIDIn != "" {
			if err := r.SetQueryParam("id__in", qIDIn); err != nil {
				return err
			}
		}

	}

	if o.IsPool != nil {

		// query param is_pool
		var qrIsPool string
		if o.IsPool != nil {
			qrIsPool = *o.IsPool
		}
		qIsPool := qrIsPool
		if qIsPool != "" {
			if err := r.SetQueryParam("is_pool", qIsPool); err != nil {
				return err
			}
		}

	}

	if o.LastUpdated != nil {

		// query param last_updated
		var qrLastUpdated string
		if o.LastUpdated != nil {
			qrLastUpdated = *o.LastUpdated
		}
		qLastUpdated := qrLastUpdated
		if qLastUpdated != "" {
			if err := r.SetQueryParam("last_updated", qLastUpdated); err != nil {
				return err
			}
		}

	}

	if o.LastUpdatedGte != nil {

		// query param last_updated__gte
		var qrLastUpdatedGte string
		if o.LastUpdatedGte != nil {
			qrLastUpdatedGte = *o.LastUpdatedGte
		}
		qLastUpdatedGte := qrLastUpdatedGte
		if qLastUpdatedGte != "" {
			if err := r.SetQueryParam("last_updated__gte", qLastUpdatedGte); err != nil {
				return err
			}
		}

	}

	if o.LastUpdatedLte != nil {

		// query param last_updated__lte
		var qrLastUpdatedLte string
		if o.LastUpdatedLte != nil {
			qrLastUpdatedLte = *o.LastUpdatedLte
		}
		qLastUpdatedLte := qrLastUpdatedLte
		if qLastUpdatedLte != "" {
			if err := r.SetQueryParam("last_updated__lte", qLastUpdatedLte); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.MaskLength != nil {

		// query param mask_length
		var qrMaskLength float64
		if o.MaskLength != nil {
			qrMaskLength = *o.MaskLength
		}
		qMaskLength := swag.FormatFloat64(qrMaskLength)
		if qMaskLength != "" {
			if err := r.SetQueryParam("mask_length", qMaskLength); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.Prefix != nil {

		// query param prefix
		var qrPrefix string
		if o.Prefix != nil {
			qrPrefix = *o.Prefix
		}
		qPrefix := qrPrefix
		if qPrefix != "" {
			if err := r.SetQueryParam("prefix", qPrefix); err != nil {
				return err
			}
		}

	}

	if o.Q != nil {

		// query param q
		var qrQ string
		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {
			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}

	}

	if o.Region != nil {

		// query param region
		var qrRegion string
		if o.Region != nil {
			qrRegion = *o.Region
		}
		qRegion := qrRegion
		if qRegion != "" {
			if err := r.SetQueryParam("region", qRegion); err != nil {
				return err
			}
		}

	}

	if o.RegionID != nil {

		// query param region_id
		var qrRegionID string
		if o.RegionID != nil {
			qrRegionID = *o.RegionID
		}
		qRegionID := qrRegionID
		if qRegionID != "" {
			if err := r.SetQueryParam("region_id", qRegionID); err != nil {
				return err
			}
		}

	}

	if o.Role != nil {

		// query param role
		var qrRole string
		if o.Role != nil {
			qrRole = *o.Role
		}
		qRole := qrRole
		if qRole != "" {
			if err := r.SetQueryParam("role", qRole); err != nil {
				return err
			}
		}

	}

	if o.RoleID != nil {

		// query param role_id
		var qrRoleID string
		if o.RoleID != nil {
			qrRoleID = *o.RoleID
		}
		qRoleID := qrRoleID
		if qRoleID != "" {
			if err := r.SetQueryParam("role_id", qRoleID); err != nil {
				return err
			}
		}

	}

	if o.Site != nil {

		// query param site
		var qrSite string
		if o.Site != nil {
			qrSite = *o.Site
		}
		qSite := qrSite
		if qSite != "" {
			if err := r.SetQueryParam("site", qSite); err != nil {
				return err
			}
		}

	}

	if o.SiteID != nil {

		// query param site_id
		var qrSiteID string
		if o.SiteID != nil {
			qrSiteID = *o.SiteID
		}
		qSiteID := qrSiteID
		if qSiteID != "" {
			if err := r.SetQueryParam("site_id", qSiteID); err != nil {
				return err
			}
		}

	}

	if o.Status != nil {

		// query param status
		var qrStatus string
		if o.Status != nil {
			qrStatus = *o.Status
		}
		qStatus := qrStatus
		if qStatus != "" {
			if err := r.SetQueryParam("status", qStatus); err != nil {
				return err
			}
		}

	}

	if o.Tag != nil {

		// query param tag
		var qrTag string
		if o.Tag != nil {
			qrTag = *o.Tag
		}
		qTag := qrTag
		if qTag != "" {
			if err := r.SetQueryParam("tag", qTag); err != nil {
				return err
			}
		}

	}

	if o.Tenant != nil {

		// query param tenant
		var qrTenant string
		if o.Tenant != nil {
			qrTenant = *o.Tenant
		}
		qTenant := qrTenant
		if qTenant != "" {
			if err := r.SetQueryParam("tenant", qTenant); err != nil {
				return err
			}
		}

	}

	if o.TenantGroup != nil {

		// query param tenant_group
		var qrTenantGroup string
		if o.TenantGroup != nil {
			qrTenantGroup = *o.TenantGroup
		}
		qTenantGroup := qrTenantGroup
		if qTenantGroup != "" {
			if err := r.SetQueryParam("tenant_group", qTenantGroup); err != nil {
				return err
			}
		}

	}

	if o.TenantGroupID != nil {

		// query param tenant_group_id
		var qrTenantGroupID string
		if o.TenantGroupID != nil {
			qrTenantGroupID = *o.TenantGroupID
		}
		qTenantGroupID := qrTenantGroupID
		if qTenantGroupID != "" {
			if err := r.SetQueryParam("tenant_group_id", qTenantGroupID); err != nil {
				return err
			}
		}

	}

	if o.TenantID != nil {

		// query param tenant_id
		var qrTenantID string
		if o.TenantID != nil {
			qrTenantID = *o.TenantID
		}
		qTenantID := qrTenantID
		if qTenantID != "" {
			if err := r.SetQueryParam("tenant_id", qTenantID); err != nil {
				return err
			}
		}

	}

	if o.VlanID != nil {

		// query param vlan_id
		var qrVlanID string
		if o.VlanID != nil {
			qrVlanID = *o.VlanID
		}
		qVlanID := qrVlanID
		if qVlanID != "" {
			if err := r.SetQueryParam("vlan_id", qVlanID); err != nil {
				return err
			}
		}

	}

	if o.VlanVid != nil {

		// query param vlan_vid
		var qrVlanVid float64
		if o.VlanVid != nil {
			qrVlanVid = *o.VlanVid
		}
		qVlanVid := swag.FormatFloat64(qrVlanVid)
		if qVlanVid != "" {
			if err := r.SetQueryParam("vlan_vid", qVlanVid); err != nil {
				return err
			}
		}

	}

	if o.Vrf != nil {

		// query param vrf
		var qrVrf string
		if o.Vrf != nil {
			qrVrf = *o.Vrf
		}
		qVrf := qrVrf
		if qVrf != "" {
			if err := r.SetQueryParam("vrf", qVrf); err != nil {
				return err
			}
		}

	}

	if o.VrfID != nil {

		// query param vrf_id
		var qrVrfID string
		if o.VrfID != nil {
			qrVrfID = *o.VrfID
		}
		qVrfID := qrVrfID
		if qVrfID != "" {
			if err := r.SetQueryParam("vrf_id", qVrfID); err != nil {
				return err
			}
		}

	}

	if o.Within != nil {

		// query param within
		var qrWithin string
		if o.Within != nil {
			qrWithin = *o.Within
		}
		qWithin := qrWithin
		if qWithin != "" {
			if err := r.SetQueryParam("within", qWithin); err != nil {
				return err
			}
		}

	}

	if o.WithinInclude != nil {

		// query param within_include
		var qrWithinInclude string
		if o.WithinInclude != nil {
			qrWithinInclude = *o.WithinInclude
		}
		qWithinInclude := qrWithinInclude
		if qWithinInclude != "" {
			if err := r.SetQueryParam("within_include", qWithinInclude); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
