// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2018 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package ipam

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewIpamRirsListParams creates a new IpamRirsListParams object
// with the default values initialized.
func NewIpamRirsListParams() *IpamRirsListParams {
	var ()
	return &IpamRirsListParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewIpamRirsListParamsWithTimeout creates a new IpamRirsListParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewIpamRirsListParamsWithTimeout(timeout time.Duration) *IpamRirsListParams {
	var ()
	return &IpamRirsListParams{

		timeout: timeout,
	}
}

// NewIpamRirsListParamsWithContext creates a new IpamRirsListParams object
// with the default values initialized, and the ability to set a context for a request
func NewIpamRirsListParamsWithContext(ctx context.Context) *IpamRirsListParams {
	var ()
	return &IpamRirsListParams{

		Context: ctx,
	}
}

// NewIpamRirsListParamsWithHTTPClient creates a new IpamRirsListParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewIpamRirsListParamsWithHTTPClient(client *http.Client) *IpamRirsListParams {
	var ()
	return &IpamRirsListParams{
		HTTPClient: client,
	}
}

/*IpamRirsListParams contains all the parameters to send to the API endpoint
for the ipam rirs list operation typically these are written to a http.Request
*/
type IpamRirsListParams struct {

	/*IDIn
	  Multiple values may be separated by commas.

	*/
	IDIn *string
	/*IsPrivate*/
	IsPrivate *string
	/*Limit
	  Number of results to return per page.

	*/
	Limit *int64
	/*Name*/
	Name *string
	/*Offset
	  The initial index from which to return the results.

	*/
	Offset *int64
	/*Q*/
	Q *string
	/*Slug*/
	Slug *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the ipam rirs list params
func (o *IpamRirsListParams) WithTimeout(timeout time.Duration) *IpamRirsListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ipam rirs list params
func (o *IpamRirsListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ipam rirs list params
func (o *IpamRirsListParams) WithContext(ctx context.Context) *IpamRirsListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ipam rirs list params
func (o *IpamRirsListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ipam rirs list params
func (o *IpamRirsListParams) WithHTTPClient(client *http.Client) *IpamRirsListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ipam rirs list params
func (o *IpamRirsListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithIDIn adds the iDIn to the ipam rirs list params
func (o *IpamRirsListParams) WithIDIn(iDIn *string) *IpamRirsListParams {
	o.SetIDIn(iDIn)
	return o
}

// SetIDIn adds the idIn to the ipam rirs list params
func (o *IpamRirsListParams) SetIDIn(iDIn *string) {
	o.IDIn = iDIn
}

// WithIsPrivate adds the isPrivate to the ipam rirs list params
func (o *IpamRirsListParams) WithIsPrivate(isPrivate *string) *IpamRirsListParams {
	o.SetIsPrivate(isPrivate)
	return o
}

// SetIsPrivate adds the isPrivate to the ipam rirs list params
func (o *IpamRirsListParams) SetIsPrivate(isPrivate *string) {
	o.IsPrivate = isPrivate
}

// WithLimit adds the limit to the ipam rirs list params
func (o *IpamRirsListParams) WithLimit(limit *int64) *IpamRirsListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the ipam rirs list params
func (o *IpamRirsListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithName adds the name to the ipam rirs list params
func (o *IpamRirsListParams) WithName(name *string) *IpamRirsListParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the ipam rirs list params
func (o *IpamRirsListParams) SetName(name *string) {
	o.Name = name
}

// WithOffset adds the offset to the ipam rirs list params
func (o *IpamRirsListParams) WithOffset(offset *int64) *IpamRirsListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the ipam rirs list params
func (o *IpamRirsListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithQ adds the q to the ipam rirs list params
func (o *IpamRirsListParams) WithQ(q *string) *IpamRirsListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the ipam rirs list params
func (o *IpamRirsListParams) SetQ(q *string) {
	o.Q = q
}

// WithSlug adds the slug to the ipam rirs list params
func (o *IpamRirsListParams) WithSlug(slug *string) *IpamRirsListParams {
	o.SetSlug(slug)
	return o
}

// SetSlug adds the slug to the ipam rirs list params
func (o *IpamRirsListParams) SetSlug(slug *string) {
	o.Slug = slug
}

// WriteToRequest writes these params to a swagger request
func (o *IpamRirsListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.IDIn != nil {

		// query param id__in
		var qrIDIn string
		if o.IDIn != nil {
			qrIDIn = *o.IDIn
		}
		qIDIn := qrIDIn
		if qIDIn != "" {
			if err := r.SetQueryParam("id__in", qIDIn); err != nil {
				return err
			}
		}

	}

	if o.IsPrivate != nil {

		// query param is_private
		var qrIsPrivate string
		if o.IsPrivate != nil {
			qrIsPrivate = *o.IsPrivate
		}
		qIsPrivate := qrIsPrivate
		if qIsPrivate != "" {
			if err := r.SetQueryParam("is_private", qIsPrivate); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Name != nil {

		// query param name
		var qrName string
		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {
			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.Q != nil {

		// query param q
		var qrQ string
		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {
			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}

	}

	if o.Slug != nil {

		// query param slug
		var qrSlug string
		if o.Slug != nil {
			qrSlug = *o.Slug
		}
		qSlug := qrSlug
		if qSlug != "" {
			if err := r.SetQueryParam("slug", qSlug); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
