// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2018 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package ipam

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"

	"github.com/netbox-community/go-netbox/netbox/models"
)

// NewIpamVlansPartialUpdateParams creates a new IpamVlansPartialUpdateParams object
// with the default values initialized.
func NewIpamVlansPartialUpdateParams() *IpamVlansPartialUpdateParams {
	var ()
	return &IpamVlansPartialUpdateParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewIpamVlansPartialUpdateParamsWithTimeout creates a new IpamVlansPartialUpdateParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewIpamVlansPartialUpdateParamsWithTimeout(timeout time.Duration) *IpamVlansPartialUpdateParams {
	var ()
	return &IpamVlansPartialUpdateParams{

		timeout: timeout,
	}
}

// NewIpamVlansPartialUpdateParamsWithContext creates a new IpamVlansPartialUpdateParams object
// with the default values initialized, and the ability to set a context for a request
func NewIpamVlansPartialUpdateParamsWithContext(ctx context.Context) *IpamVlansPartialUpdateParams {
	var ()
	return &IpamVlansPartialUpdateParams{

		Context: ctx,
	}
}

// NewIpamVlansPartialUpdateParamsWithHTTPClient creates a new IpamVlansPartialUpdateParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewIpamVlansPartialUpdateParamsWithHTTPClient(client *http.Client) *IpamVlansPartialUpdateParams {
	var ()
	return &IpamVlansPartialUpdateParams{
		HTTPClient: client,
	}
}

/*IpamVlansPartialUpdateParams contains all the parameters to send to the API endpoint
for the ipam vlans partial update operation typically these are written to a http.Request
*/
type IpamVlansPartialUpdateParams struct {

	/*Data*/
	Data *models.WritableVLAN
	/*ID
	  A unique integer value identifying this VLAN.

	*/
	ID int64

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the ipam vlans partial update params
func (o *IpamVlansPartialUpdateParams) WithTimeout(timeout time.Duration) *IpamVlansPartialUpdateParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the ipam vlans partial update params
func (o *IpamVlansPartialUpdateParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the ipam vlans partial update params
func (o *IpamVlansPartialUpdateParams) WithContext(ctx context.Context) *IpamVlansPartialUpdateParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the ipam vlans partial update params
func (o *IpamVlansPartialUpdateParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the ipam vlans partial update params
func (o *IpamVlansPartialUpdateParams) WithHTTPClient(client *http.Client) *IpamVlansPartialUpdateParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the ipam vlans partial update params
func (o *IpamVlansPartialUpdateParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithData adds the data to the ipam vlans partial update params
func (o *IpamVlansPartialUpdateParams) WithData(data *models.WritableVLAN) *IpamVlansPartialUpdateParams {
	o.SetData(data)
	return o
}

// SetData adds the data to the ipam vlans partial update params
func (o *IpamVlansPartialUpdateParams) SetData(data *models.WritableVLAN) {
	o.Data = data
}

// WithID adds the id to the ipam vlans partial update params
func (o *IpamVlansPartialUpdateParams) WithID(id int64) *IpamVlansPartialUpdateParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the ipam vlans partial update params
func (o *IpamVlansPartialUpdateParams) SetID(id int64) {
	o.ID = id
}

// WriteToRequest writes these params to a swagger request
func (o *IpamVlansPartialUpdateParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.Data != nil {
		if err := r.SetBodyParam(o.Data); err != nil {
			return err
		}
	}

	// path param id
	if err := r.SetPathParam("id", swag.FormatInt64(o.ID)); err != nil {
		return err
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
