// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2018 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//

package models

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"encoding/json"

	"github.com/go-openapi/errors"
	strfmt "github.com/go-openapi/strfmt"
	"github.com/go-openapi/swag"
	"github.com/go-openapi/validate"
)

// WritablePowerOutletTemplate writable power outlet template
// swagger:model WritablePowerOutletTemplate
type WritablePowerOutletTemplate struct {

	// Device type
	// Required: true
	DeviceType *int64 `json:"device_type"`

	// Feed leg
	//
	// Phase (for three-phase feeds)
	// Enum: [A B C]
	FeedLeg string `json:"feed_leg,omitempty"`

	// ID
	// Read Only: true
	ID int64 `json:"id,omitempty"`

	// Name
	// Required: true
	// Max Length: 50
	// Min Length: 1
	Name *string `json:"name"`

	// power port
	PowerPort *PowerPortTemplate `json:"power_port,omitempty"`

	// Type
	// Enum: [iec-60320-c5 iec-60320-c7 iec-60320-c13 iec-60320-c15 iec-60320-c19 iec-60309-p-n-e-4h iec-60309-p-n-e-6h iec-60309-p-n-e-9h iec-60309-2p-e-4h iec-60309-2p-e-6h iec-60309-2p-e-9h iec-60309-3p-e-4h iec-60309-3p-e-6h iec-60309-3p-e-9h iec-60309-3p-n-e-4h iec-60309-3p-n-e-6h iec-60309-3p-n-e-9h nema-5-15r nema-5-20r nema-5-30r nema-5-50r nema-6-15r nema-6-20r nema-6-30r nema-6-50r nema-l5-15r nema-l5-20r nema-l5-30r nema-l5-50r nema-l6-20r nema-l6-30r nema-l6-50r CS6360C CS6364C CS8164C CS8264C CS8364C CS8464C ita-e ita-f ita-g ita-h ita-i ita-j ita-k ita-l ita-m ita-n ita-o]
	Type string `json:"type,omitempty"`
}

// Validate validates this writable power outlet template
func (m *WritablePowerOutletTemplate) Validate(formats strfmt.Registry) error {
	var res []error

	if err := m.validateDeviceType(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateFeedLeg(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateName(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validatePowerPort(formats); err != nil {
		res = append(res, err)
	}

	if err := m.validateType(formats); err != nil {
		res = append(res, err)
	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}

func (m *WritablePowerOutletTemplate) validateDeviceType(formats strfmt.Registry) error {

	if err := validate.Required("device_type", "body", m.DeviceType); err != nil {
		return err
	}

	return nil
}

var writablePowerOutletTemplateTypeFeedLegPropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["A","B","C"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		writablePowerOutletTemplateTypeFeedLegPropEnum = append(writablePowerOutletTemplateTypeFeedLegPropEnum, v)
	}
}

const (

	// WritablePowerOutletTemplateFeedLegA captures enum value "A"
	WritablePowerOutletTemplateFeedLegA string = "A"

	// WritablePowerOutletTemplateFeedLegB captures enum value "B"
	WritablePowerOutletTemplateFeedLegB string = "B"

	// WritablePowerOutletTemplateFeedLegC captures enum value "C"
	WritablePowerOutletTemplateFeedLegC string = "C"
)

// prop value enum
func (m *WritablePowerOutletTemplate) validateFeedLegEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, writablePowerOutletTemplateTypeFeedLegPropEnum); err != nil {
		return err
	}
	return nil
}

func (m *WritablePowerOutletTemplate) validateFeedLeg(formats strfmt.Registry) error {

	if swag.IsZero(m.FeedLeg) { // not required
		return nil
	}

	// value enum
	if err := m.validateFeedLegEnum("feed_leg", "body", m.FeedLeg); err != nil {
		return err
	}

	return nil
}

func (m *WritablePowerOutletTemplate) validateName(formats strfmt.Registry) error {

	if err := validate.Required("name", "body", m.Name); err != nil {
		return err
	}

	if err := validate.MinLength("name", "body", string(*m.Name), 1); err != nil {
		return err
	}

	if err := validate.MaxLength("name", "body", string(*m.Name), 50); err != nil {
		return err
	}

	return nil
}

func (m *WritablePowerOutletTemplate) validatePowerPort(formats strfmt.Registry) error {

	if swag.IsZero(m.PowerPort) { // not required
		return nil
	}

	if m.PowerPort != nil {
		if err := m.PowerPort.Validate(formats); err != nil {
			if ve, ok := err.(*errors.Validation); ok {
				return ve.ValidateName("power_port")
			}
			return err
		}
	}

	return nil
}

var writablePowerOutletTemplateTypeTypePropEnum []interface{}

func init() {
	var res []string
	if err := json.Unmarshal([]byte(`["iec-60320-c5","iec-60320-c7","iec-60320-c13","iec-60320-c15","iec-60320-c19","iec-60309-p-n-e-4h","iec-60309-p-n-e-6h","iec-60309-p-n-e-9h","iec-60309-2p-e-4h","iec-60309-2p-e-6h","iec-60309-2p-e-9h","iec-60309-3p-e-4h","iec-60309-3p-e-6h","iec-60309-3p-e-9h","iec-60309-3p-n-e-4h","iec-60309-3p-n-e-6h","iec-60309-3p-n-e-9h","nema-5-15r","nema-5-20r","nema-5-30r","nema-5-50r","nema-6-15r","nema-6-20r","nema-6-30r","nema-6-50r","nema-l5-15r","nema-l5-20r","nema-l5-30r","nema-l5-50r","nema-l6-20r","nema-l6-30r","nema-l6-50r","CS6360C","CS6364C","CS8164C","CS8264C","CS8364C","CS8464C","ita-e","ita-f","ita-g","ita-h","ita-i","ita-j","ita-k","ita-l","ita-m","ita-n","ita-o"]`), &res); err != nil {
		panic(err)
	}
	for _, v := range res {
		writablePowerOutletTemplateTypeTypePropEnum = append(writablePowerOutletTemplateTypeTypePropEnum, v)
	}
}

const (

	// WritablePowerOutletTemplateTypeIec60320C5 captures enum value "iec-60320-c5"
	WritablePowerOutletTemplateTypeIec60320C5 string = "iec-60320-c5"

	// WritablePowerOutletTemplateTypeIec60320C7 captures enum value "iec-60320-c7"
	WritablePowerOutletTemplateTypeIec60320C7 string = "iec-60320-c7"

	// WritablePowerOutletTemplateTypeIec60320C13 captures enum value "iec-60320-c13"
	WritablePowerOutletTemplateTypeIec60320C13 string = "iec-60320-c13"

	// WritablePowerOutletTemplateTypeIec60320C15 captures enum value "iec-60320-c15"
	WritablePowerOutletTemplateTypeIec60320C15 string = "iec-60320-c15"

	// WritablePowerOutletTemplateTypeIec60320C19 captures enum value "iec-60320-c19"
	WritablePowerOutletTemplateTypeIec60320C19 string = "iec-60320-c19"

	// WritablePowerOutletTemplateTypeIec60309pne4h captures enum value "iec-60309-p-n-e-4h"
	WritablePowerOutletTemplateTypeIec60309pne4h string = "iec-60309-p-n-e-4h"

	// WritablePowerOutletTemplateTypeIec60309pne6h captures enum value "iec-60309-p-n-e-6h"
	WritablePowerOutletTemplateTypeIec60309pne6h string = "iec-60309-p-n-e-6h"

	// WritablePowerOutletTemplateTypeIec60309pne9h captures enum value "iec-60309-p-n-e-9h"
	WritablePowerOutletTemplateTypeIec60309pne9h string = "iec-60309-p-n-e-9h"

	// WritablePowerOutletTemplateTypeIec603092pe4h captures enum value "iec-60309-2p-e-4h"
	WritablePowerOutletTemplateTypeIec603092pe4h string = "iec-60309-2p-e-4h"

	// WritablePowerOutletTemplateTypeIec603092pe6h captures enum value "iec-60309-2p-e-6h"
	WritablePowerOutletTemplateTypeIec603092pe6h string = "iec-60309-2p-e-6h"

	// WritablePowerOutletTemplateTypeIec603092pe9h captures enum value "iec-60309-2p-e-9h"
	WritablePowerOutletTemplateTypeIec603092pe9h string = "iec-60309-2p-e-9h"

	// WritablePowerOutletTemplateTypeIec603093pe4h captures enum value "iec-60309-3p-e-4h"
	WritablePowerOutletTemplateTypeIec603093pe4h string = "iec-60309-3p-e-4h"

	// WritablePowerOutletTemplateTypeIec603093pe6h captures enum value "iec-60309-3p-e-6h"
	WritablePowerOutletTemplateTypeIec603093pe6h string = "iec-60309-3p-e-6h"

	// WritablePowerOutletTemplateTypeIec603093pe9h captures enum value "iec-60309-3p-e-9h"
	WritablePowerOutletTemplateTypeIec603093pe9h string = "iec-60309-3p-e-9h"

	// WritablePowerOutletTemplateTypeIec603093pne4h captures enum value "iec-60309-3p-n-e-4h"
	WritablePowerOutletTemplateTypeIec603093pne4h string = "iec-60309-3p-n-e-4h"

	// WritablePowerOutletTemplateTypeIec603093pne6h captures enum value "iec-60309-3p-n-e-6h"
	WritablePowerOutletTemplateTypeIec603093pne6h string = "iec-60309-3p-n-e-6h"

	// WritablePowerOutletTemplateTypeIec603093pne9h captures enum value "iec-60309-3p-n-e-9h"
	WritablePowerOutletTemplateTypeIec603093pne9h string = "iec-60309-3p-n-e-9h"

	// WritablePowerOutletTemplateTypeNema515r captures enum value "nema-5-15r"
	WritablePowerOutletTemplateTypeNema515r string = "nema-5-15r"

	// WritablePowerOutletTemplateTypeNema520r captures enum value "nema-5-20r"
	WritablePowerOutletTemplateTypeNema520r string = "nema-5-20r"

	// WritablePowerOutletTemplateTypeNema530r captures enum value "nema-5-30r"
	WritablePowerOutletTemplateTypeNema530r string = "nema-5-30r"

	// WritablePowerOutletTemplateTypeNema550r captures enum value "nema-5-50r"
	WritablePowerOutletTemplateTypeNema550r string = "nema-5-50r"

	// WritablePowerOutletTemplateTypeNema615r captures enum value "nema-6-15r"
	WritablePowerOutletTemplateTypeNema615r string = "nema-6-15r"

	// WritablePowerOutletTemplateTypeNema620r captures enum value "nema-6-20r"
	WritablePowerOutletTemplateTypeNema620r string = "nema-6-20r"

	// WritablePowerOutletTemplateTypeNema630r captures enum value "nema-6-30r"
	WritablePowerOutletTemplateTypeNema630r string = "nema-6-30r"

	// WritablePowerOutletTemplateTypeNema650r captures enum value "nema-6-50r"
	WritablePowerOutletTemplateTypeNema650r string = "nema-6-50r"

	// WritablePowerOutletTemplateTypeNemaL515r captures enum value "nema-l5-15r"
	WritablePowerOutletTemplateTypeNemaL515r string = "nema-l5-15r"

	// WritablePowerOutletTemplateTypeNemaL520r captures enum value "nema-l5-20r"
	WritablePowerOutletTemplateTypeNemaL520r string = "nema-l5-20r"

	// WritablePowerOutletTemplateTypeNemaL530r captures enum value "nema-l5-30r"
	WritablePowerOutletTemplateTypeNemaL530r string = "nema-l5-30r"

	// WritablePowerOutletTemplateTypeNemaL550r captures enum value "nema-l5-50r"
	WritablePowerOutletTemplateTypeNemaL550r string = "nema-l5-50r"

	// WritablePowerOutletTemplateTypeNemaL620r captures enum value "nema-l6-20r"
	WritablePowerOutletTemplateTypeNemaL620r string = "nema-l6-20r"

	// WritablePowerOutletTemplateTypeNemaL630r captures enum value "nema-l6-30r"
	WritablePowerOutletTemplateTypeNemaL630r string = "nema-l6-30r"

	// WritablePowerOutletTemplateTypeNemaL650r captures enum value "nema-l6-50r"
	WritablePowerOutletTemplateTypeNemaL650r string = "nema-l6-50r"

	// WritablePowerOutletTemplateTypeCS6360C captures enum value "CS6360C"
	WritablePowerOutletTemplateTypeCS6360C string = "CS6360C"

	// WritablePowerOutletTemplateTypeCS6364C captures enum value "CS6364C"
	WritablePowerOutletTemplateTypeCS6364C string = "CS6364C"

	// WritablePowerOutletTemplateTypeCS8164C captures enum value "CS8164C"
	WritablePowerOutletTemplateTypeCS8164C string = "CS8164C"

	// WritablePowerOutletTemplateTypeCS8264C captures enum value "CS8264C"
	WritablePowerOutletTemplateTypeCS8264C string = "CS8264C"

	// WritablePowerOutletTemplateTypeCS8364C captures enum value "CS8364C"
	WritablePowerOutletTemplateTypeCS8364C string = "CS8364C"

	// WritablePowerOutletTemplateTypeCS8464C captures enum value "CS8464C"
	WritablePowerOutletTemplateTypeCS8464C string = "CS8464C"

	// WritablePowerOutletTemplateTypeItae captures enum value "ita-e"
	WritablePowerOutletTemplateTypeItae string = "ita-e"

	// WritablePowerOutletTemplateTypeItaf captures enum value "ita-f"
	WritablePowerOutletTemplateTypeItaf string = "ita-f"

	// WritablePowerOutletTemplateTypeItag captures enum value "ita-g"
	WritablePowerOutletTemplateTypeItag string = "ita-g"

	// WritablePowerOutletTemplateTypeItah captures enum value "ita-h"
	WritablePowerOutletTemplateTypeItah string = "ita-h"

	// WritablePowerOutletTemplateTypeItai captures enum value "ita-i"
	WritablePowerOutletTemplateTypeItai string = "ita-i"

	// WritablePowerOutletTemplateTypeItaj captures enum value "ita-j"
	WritablePowerOutletTemplateTypeItaj string = "ita-j"

	// WritablePowerOutletTemplateTypeItak captures enum value "ita-k"
	WritablePowerOutletTemplateTypeItak string = "ita-k"

	// WritablePowerOutletTemplateTypeItal captures enum value "ita-l"
	WritablePowerOutletTemplateTypeItal string = "ita-l"

	// WritablePowerOutletTemplateTypeItam captures enum value "ita-m"
	WritablePowerOutletTemplateTypeItam string = "ita-m"

	// WritablePowerOutletTemplateTypeItan captures enum value "ita-n"
	WritablePowerOutletTemplateTypeItan string = "ita-n"

	// WritablePowerOutletTemplateTypeItao captures enum value "ita-o"
	WritablePowerOutletTemplateTypeItao string = "ita-o"
)

// prop value enum
func (m *WritablePowerOutletTemplate) validateTypeEnum(path, location string, value string) error {
	if err := validate.Enum(path, location, value, writablePowerOutletTemplateTypeTypePropEnum); err != nil {
		return err
	}
	return nil
}

func (m *WritablePowerOutletTemplate) validateType(formats strfmt.Registry) error {

	if swag.IsZero(m.Type) { // not required
		return nil
	}

	// value enum
	if err := m.validateTypeEnum("type", "body", m.Type); err != nil {
		return err
	}

	return nil
}

// MarshalBinary interface implementation
func (m *WritablePowerOutletTemplate) MarshalBinary() ([]byte, error) {
	if m == nil {
		return nil, nil
	}
	return swag.WriteJSON(m)
}

// UnmarshalBinary interface implementation
func (m *WritablePowerOutletTemplate) UnmarshalBinary(b []byte) error {
	var res WritablePowerOutletTemplate
	if err := swag.ReadJSON(b, &res); err != nil {
		return err
	}
	*m = res
	return nil
}
