// Code generated by go-swagger; DO NOT EDIT.

// Copyright 2018 The go-netbox Authors.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//   http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.

package virtualization

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"context"
	"net/http"
	"time"

	"github.com/go-openapi/errors"
	"github.com/go-openapi/runtime"
	cr "github.com/go-openapi/runtime/client"
	"github.com/go-openapi/swag"

	strfmt "github.com/go-openapi/strfmt"
)

// NewVirtualizationClusterTypesListParams creates a new VirtualizationClusterTypesListParams object
// with the default values initialized.
func NewVirtualizationClusterTypesListParams() *VirtualizationClusterTypesListParams {
	var ()
	return &VirtualizationClusterTypesListParams{

		timeout: cr.DefaultTimeout,
	}
}

// NewVirtualizationClusterTypesListParamsWithTimeout creates a new VirtualizationClusterTypesListParams object
// with the default values initialized, and the ability to set a timeout on a request
func NewVirtualizationClusterTypesListParamsWithTimeout(timeout time.Duration) *VirtualizationClusterTypesListParams {
	var ()
	return &VirtualizationClusterTypesListParams{

		timeout: timeout,
	}
}

// NewVirtualizationClusterTypesListParamsWithContext creates a new VirtualizationClusterTypesListParams object
// with the default values initialized, and the ability to set a context for a request
func NewVirtualizationClusterTypesListParamsWithContext(ctx context.Context) *VirtualizationClusterTypesListParams {
	var ()
	return &VirtualizationClusterTypesListParams{

		Context: ctx,
	}
}

// NewVirtualizationClusterTypesListParamsWithHTTPClient creates a new VirtualizationClusterTypesListParams object
// with the default values initialized, and the ability to set a custom HTTPClient for a request
func NewVirtualizationClusterTypesListParamsWithHTTPClient(client *http.Client) *VirtualizationClusterTypesListParams {
	var ()
	return &VirtualizationClusterTypesListParams{
		HTTPClient: client,
	}
}

/*VirtualizationClusterTypesListParams contains all the parameters to send to the API endpoint
for the virtualization cluster types list operation typically these are written to a http.Request
*/
type VirtualizationClusterTypesListParams struct {

	/*ID*/
	ID *string
	/*Limit
	  Number of results to return per page.

	*/
	Limit *int64
	/*Name*/
	Name *string
	/*Offset
	  The initial index from which to return the results.

	*/
	Offset *int64
	/*Q*/
	Q *string
	/*Slug*/
	Slug *string

	timeout    time.Duration
	Context    context.Context
	HTTPClient *http.Client
}

// WithTimeout adds the timeout to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) WithTimeout(timeout time.Duration) *VirtualizationClusterTypesListParams {
	o.SetTimeout(timeout)
	return o
}

// SetTimeout adds the timeout to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) SetTimeout(timeout time.Duration) {
	o.timeout = timeout
}

// WithContext adds the context to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) WithContext(ctx context.Context) *VirtualizationClusterTypesListParams {
	o.SetContext(ctx)
	return o
}

// SetContext adds the context to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) SetContext(ctx context.Context) {
	o.Context = ctx
}

// WithHTTPClient adds the HTTPClient to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) WithHTTPClient(client *http.Client) *VirtualizationClusterTypesListParams {
	o.SetHTTPClient(client)
	return o
}

// SetHTTPClient adds the HTTPClient to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) SetHTTPClient(client *http.Client) {
	o.HTTPClient = client
}

// WithID adds the id to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) WithID(id *string) *VirtualizationClusterTypesListParams {
	o.SetID(id)
	return o
}

// SetID adds the id to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) SetID(id *string) {
	o.ID = id
}

// WithLimit adds the limit to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) WithLimit(limit *int64) *VirtualizationClusterTypesListParams {
	o.SetLimit(limit)
	return o
}

// SetLimit adds the limit to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) SetLimit(limit *int64) {
	o.Limit = limit
}

// WithName adds the name to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) WithName(name *string) *VirtualizationClusterTypesListParams {
	o.SetName(name)
	return o
}

// SetName adds the name to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) SetName(name *string) {
	o.Name = name
}

// WithOffset adds the offset to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) WithOffset(offset *int64) *VirtualizationClusterTypesListParams {
	o.SetOffset(offset)
	return o
}

// SetOffset adds the offset to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) SetOffset(offset *int64) {
	o.Offset = offset
}

// WithQ adds the q to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) WithQ(q *string) *VirtualizationClusterTypesListParams {
	o.SetQ(q)
	return o
}

// SetQ adds the q to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) SetQ(q *string) {
	o.Q = q
}

// WithSlug adds the slug to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) WithSlug(slug *string) *VirtualizationClusterTypesListParams {
	o.SetSlug(slug)
	return o
}

// SetSlug adds the slug to the virtualization cluster types list params
func (o *VirtualizationClusterTypesListParams) SetSlug(slug *string) {
	o.Slug = slug
}

// WriteToRequest writes these params to a swagger request
func (o *VirtualizationClusterTypesListParams) WriteToRequest(r runtime.ClientRequest, reg strfmt.Registry) error {

	if err := r.SetTimeout(o.timeout); err != nil {
		return err
	}
	var res []error

	if o.ID != nil {

		// query param id
		var qrID string
		if o.ID != nil {
			qrID = *o.ID
		}
		qID := qrID
		if qID != "" {
			if err := r.SetQueryParam("id", qID); err != nil {
				return err
			}
		}

	}

	if o.Limit != nil {

		// query param limit
		var qrLimit int64
		if o.Limit != nil {
			qrLimit = *o.Limit
		}
		qLimit := swag.FormatInt64(qrLimit)
		if qLimit != "" {
			if err := r.SetQueryParam("limit", qLimit); err != nil {
				return err
			}
		}

	}

	if o.Name != nil {

		// query param name
		var qrName string
		if o.Name != nil {
			qrName = *o.Name
		}
		qName := qrName
		if qName != "" {
			if err := r.SetQueryParam("name", qName); err != nil {
				return err
			}
		}

	}

	if o.Offset != nil {

		// query param offset
		var qrOffset int64
		if o.Offset != nil {
			qrOffset = *o.Offset
		}
		qOffset := swag.FormatInt64(qrOffset)
		if qOffset != "" {
			if err := r.SetQueryParam("offset", qOffset); err != nil {
				return err
			}
		}

	}

	if o.Q != nil {

		// query param q
		var qrQ string
		if o.Q != nil {
			qrQ = *o.Q
		}
		qQ := qrQ
		if qQ != "" {
			if err := r.SetQueryParam("q", qQ); err != nil {
				return err
			}
		}

	}

	if o.Slug != nil {

		// query param slug
		var qrSlug string
		if o.Slug != nil {
			qrSlug = *o.Slug
		}
		qSlug := qrSlug
		if qSlug != "" {
			if err := r.SetQueryParam("slug", qSlug); err != nil {
				return err
			}
		}

	}

	if len(res) > 0 {
		return errors.CompositeValidationError(res...)
	}
	return nil
}
